﻿B4J=true
Group=Handlers
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
' Web Handler class
' Version 2.02
Sub Class_Globals
	Private Request As ServletRequest
	Private Response As ServletResponse
	Private Elements() As String
	Private Method As String
	Private HRM As HttpResponseMessage
End Sub

Public Sub Initialize
	HRM.Initialize
End Sub

Sub Handle (req As ServletRequest, resp As ServletResponse)
	Request = req
	Response = resp
	
	Method = Request.Method.ToUpperCase
	ProcessRequest
End Sub

Private Sub ElementLastIndex As Int
	Return Elements.Length - 1
End Sub

Private Sub ProcessRequest
	Log(Request.RequestURI)
	Elements = Utility.GetUriElements(Request.RequestURI)

	' Handle /web/
	If ElementLastIndex < Main.Element.WebControllerIndex Then
		Select Method
			Case "GET"
				Dim WelcomePage As IndexController
				WelcomePage.Initialize(Request, Response)
				WelcomePage.Show
				Return
		End Select
	End If
	
	Dim ControllerIndex As Int = Main.Element.WebControllerIndex
	Dim ControllerElement As String = Elements(ControllerIndex)	
	Select ControllerElement
		Case "sample" ' "download"
			RouteDownload(ControllerIndex)
			Return
	End Select
	Utility.ReturnHtmlPageNotFound(Response)
End Sub

Private Sub RouteDownload (ControllerIndex As Int)
	Select Method
		Case "GET"
			RouteDownloadGet(ControllerIndex)
	End Select
End Sub

Private Sub RouteDownloadGet (ControllerIndex As Int)
	Dim Download As DownloadController
	Download.Initialize(Request, Response)
	Select ElementLastIndex
		Case ControllerIndex
			Download.GetPDF
	End Select
End Sub